
#define DIS_ADD(r,i1,i2)        \
{                               \
  (r).i = (i1).i + (i2).i;      \
  (r).s = (i1).s + (i2).s;      \
}
#define DIS_MUL(res, a, b)                                      \
{                                                               \
  if ((a).i<=0)                                   /* a>=0 */    \
  {                                                             \
    if ((b).i<=0)                                 /* b>=0 */    \
    {                                                           \
      (res).i = (-(a).i)*(b).i;                                 \
      (res).s = (a).s*(b).s;                                    \
    }                                                           \
    else if ((b).s<=0)                            /* b<=0 */    \
    {                                                           \
      double tmp;                                               \
      tmp = (a).s*(b).i;                                        \
      (res).s = (-(a).i)*(b).s;                                 \
      (res).i = tmp;                                            \
    }                                                           \
    else                                        /* 0 \in b */   \
    {                                                           \
      double tmp;                                               \
      tmp = (a).s*(b).i;                                        \
      (res).s = (a).s*(b).s;                                    \
      (res).i = tmp;                                            \
    };                                                          \
  }                                                             \
  else if ((a).s<=0)                              /* a<=0 */    \
  {                                                             \
    if ((b).i<=0)                                 /* b>=0 */    \
    {                                                           \
      double tmp;                                               \
      tmp = (a).i*(b).s;                                        \
      (res).s = (a).s*(-(b).i);                                 \
      (res).i = tmp;                                            \
    }                                                           \
    else if ((b).s<=0)                            /* b<=0 */    \
    {                                                           \
      double tmp;                                               \
      tmp = (-(a).s)*(b).s;                                     \
      (res).s = (a).i*(b).i;                                    \
      (res).i = tmp;                                            \
    }                                                           \
    else                                        /* 0 \in b */   \
    {                                                           \
      double tmp;                                               \
      tmp = (a).i*(b).s;                                        \
      (res).s = (a).i*(b).i;                                    \
      (res).i = tmp;                                            \
    };                                                          \
  }                                                             \
  else                                          /* 0 \in [(a).i;(a).s] */   \
  {                                                             \
    if ((b).i<=0)                                 /* b>=0 */    \
    {                                                           \
      double tmp;                                               \
      tmp = (a).i*(b).s;                                        \
      (res).s = (a).s*(b).s;                                    \
      (res).i = tmp;                                            \
    }                                                           \
    else if ((b).s<=0)                            /* b<=0 */    \
    {                                                           \
      double tmp;                                               \
      tmp = (a).s*(b).i;                                        \
      (res).s = (a).i*(b).i;                                    \
      (res).i = tmp;                                            \
    }                                                           \
    else                                        /* 0 \in b */   \
    {                                                           \
      double tmp, tmp1, tmp2;                                   \
      tmp1 = (a).i*(b).s;                                       \
      tmp2 = (a).s*(b).i;                                       \
      tmp = (tmp1>tmp2) ? tmp1 : tmp2;                          \
      tmp1 = (a).i*(b).i;                                       \
      tmp2 = (a).s*(b).s;                                       \
      (res).s = (tmp1>tmp2) ? tmp1 : tmp2;                      \
      (res).i = tmp;                                            \
    };                                                          \
  }                                                             \
}


#define DIS_DIV(res,a,b) 					\
{								\
  if ((b).i<0)                            /* b>0 */		\
  {								\
    if ((a).i<=0)                         /* a>=0 */		\
    {								\
      double tmp;						\
      tmp = (a).i/(b).s;					\
      (res).s = (a).s/(-(b).i);					\
      (res).i = tmp;						\
    }								\
    else if ((a).s<=0)                    /* a<=0 */		\
    {								\
      double tmp;						\
      tmp = (a).i/(-(b).i);					\
      (res).s = (a).s/(b).s;					\
      (res).i = tmp;						\
    }								\
    else                                /* 0 \in a */		\
    {								\
      double tmp;						\
      tmp = (a).i/(-(b).i);					\
      (res).s = (a).s/(-(b).i);					\
      (res).i = tmp;						\
    };								\
  }								\
  else if ((b).s<0)                       /* b<0 */		\
  {								\
    if ((a).i<=0)                         /* a>=0 */		\
    {								\
      double tmp;						\
      tmp = (a).s/(-(b).s);					\
      (res).s = (a).i/(b).i;					\
      (res).i = tmp;						\
    }								\
    else if ((a).s<=0)                    /* a<=0 */		\
    {								\
      double tmp;						\
      tmp = (a).s/(b).i;					\
      (res).s = (a).i/(-(b).s);					\
      (res).i = tmp;						\
    }								\
    else                                /* 0 \in a */		\
    {								\
      double tmp;						\
      tmp = (a).s/(-(b).s);					\
      (res).s = (a).i/(-(b).s);					\
      (res).i = tmp;						\
    };								\
  }								\
  else                            /* 0 \in [(b).i;(b).s] :-) */	\
  {								\
    (res).i = (res).s = HUGE_VAL;				\
  };								\
}

